Index: src/newlib/libc/machine/cris/sys/signal.h
diff -u /dev/null src/newlib/libc/machine/cris/sys/signal.h:1.1
--- /dev/null	Thu May 12 14:25:18 2005
+++ src/newlib/libc/machine/cris/sys/signal.h	Thu Jan 27 23:54:46 2005
@@ -0,0 +1,89 @@
+/* This file is to be kept in sync (well, reasonably so, it's quite
+   different) with newlib/libc/include/sys/signal.h on which it is
+   based, except values used or returned by syscalls must be those of
+   the Linux/CRIS kernel.  */
+
+/* sys/signal.h */
+
+#ifndef _SYS_SIGNAL_H
+#define _SYS_SIGNAL_H
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#include "_ansi.h"
+
+typedef unsigned long sigset_t;
+
+/* Adjusted to linux, has unused sa_restorer field and unsigned long
+   sa_flags; relatively unimportant though.  */
+/* Type of a signal handler.  */
+typedef void (*__sighandler_t)(int);
+
+/* The type used in newlib sources.  */
+typedef __sighandler_t _sig_func_ptr;
+
+struct sigaction {
+	__sighandler_t sa_handler;
+	sigset_t sa_mask;
+	unsigned long sa_flags;
+	void (*sa_restorer)(void);
+};
+
+/* Adjusted to glibc; other values.  */
+#define SA_NOCLDSTOP 1	/* only value supported now for sa_flags */
+#define SIG_SETMASK 2	/* set mask with sigprocmask() */
+#define SIG_BLOCK 0	/* set of signals to block */
+#define SIG_UNBLOCK 1	/* set of signals to, well, unblock */
+
+/* These depend upon the type of sigset_t, which right now
+   is always a long.. They're in the POSIX namespace, but
+   are not ANSI. */
+#define sigaddset(what,sig) (*(what) |= (1<<(sig)))
+#define sigemptyset(what)   (*(what) = 0)
+
+int sigprocmask (int __how, const sigset_t *__a, sigset_t *__b);
+
+#define SIGHUP		 1
+#define SIGINT		 2
+#define SIGQUIT		 3
+#define SIGILL		 4
+#define SIGTRAP		 5
+#define SIGABRT		 6
+#define SIGIOT		 6
+#define SIGBUS		 7
+#define SIGFPE		 8
+#define SIGKILL		 9
+#define SIGUSR1		10
+#define SIGSEGV		11
+#define SIGUSR2		12
+#define SIGPIPE		13
+#define SIGALRM		14
+#define SIGTERM		15
+#define SIGSTKFLT	16
+#define SIGCHLD		17
+#define SIGCONT		18
+#define SIGSTOP		19
+#define SIGTSTP		20
+#define SIGTTIN		21
+#define SIGTTOU		22
+#define SIGURG		23
+#define SIGXCPU		24
+#define SIGXFSZ		25
+#define SIGVTALRM	26
+#define SIGPROF		27
+#define SIGWINCH	28
+#define SIGIO		29
+#define SIGPOLL		SIGIO
+#define SIGPWR		30
+#define	NSIG 31
+
+#ifdef __cplusplus
+}
+#endif
+#ifndef _SIGNAL_H_
+/* Some applications take advantage of the fact that <sys/signal.h>
+ * and <signal.h> are equivalent in glibc.  Allow for that here.  */
+#include <signal.h>
+#endif
+#endif /* _SYS_SIGNAL_H */
Index: src/newlib/libc/machine/powerpc/vfprintf.c
diff -u src/newlib/libc/machine/powerpc/vfprintf.c:1.9 src/newlib/libc/machine/powerpc/vfprintf.c:1.11
--- src/newlib/libc/machine/powerpc/vfprintf.c:1.9	Wed May 26 00:19:14 2004
+++ src/newlib/libc/machine/powerpc/vfprintf.c	Tue Feb  8 01:33:16 2005
@@ -135,7 +135,7 @@
 
 #if defined(LIBC_SCCS) && !defined(lint)
 /*static char *sccsid = "from: @(#)vfprintf.c	5.50 (Berkeley) 12/16/92";*/
-static char *rcsid = "$Id: vfprintf.c,v 1.9 2004/05/26 00:19:14 jjohnstn Exp $";
+static char *rcsid = "$Id: vfprintf.c,v 1.11 2005/02/08 01:33:16 jjohnstn Exp $";
 #endif /* LIBC_SCCS and not lint */
 
 /*
@@ -239,7 +239,6 @@
 	unsigned char buf[BUFSIZ];
 
 	/* copy the important variables */
-	fake._data = fp->_data;
 	fake._flags = fp->_flags & ~__SNBF;
 	fake._file = fp->_file;
 	fake._cookie = fp->_cookie;
@@ -322,8 +321,8 @@
 	_CONST char *fmt0 _AND
 	va_list ap)
 {
-  CHECK_INIT (fp);
-  return _VFPRINTF_R (fp->_data, fp, fmt0, ap);
+  CHECK_INIT (_REENT);
+  return _VFPRINTF_R (_REENT, fp, fmt0, ap);
 }
 
 int 
Index: src/newlib/libc/machine/powerpc/vfscanf.c
diff -u src/newlib/libc/machine/powerpc/vfscanf.c:1.14 src/newlib/libc/machine/powerpc/vfscanf.c:1.15
--- src/newlib/libc/machine/powerpc/vfscanf.c:1.14	Wed Nov 24 00:45:41 2004
+++ src/newlib/libc/machine/powerpc/vfscanf.c	Tue Feb  8 01:33:16 2005
@@ -224,8 +224,8 @@
     _CONST char *fmt _AND 
     va_list ap)
 {
-  CHECK_INIT(fp);
-  return __svfscanf_r (fp->_data, fp, fmt, ap);
+  CHECK_INIT(_REENT);
+  return __svfscanf_r (_REENT, fp, fmt, ap);
 }
 
 int
Index: src/newlib/libc/misc/Makefile.am
diff -u src/newlib/libc/misc/Makefile.am:1.2 src/newlib/libc/misc/Makefile.am:1.3
--- src/newlib/libc/misc/Makefile.am:1.2	Thu Dec 13 23:49:54 2001
+++ src/newlib/libc/misc/Makefile.am	Fri Jan  7 18:04:38 2005
@@ -4,7 +4,7 @@
 
 INCLUDES = $(NEWLIB_CFLAGS) $(CROSS_CFLAGS) $(TARGET_CFLAGS)
 
-LIB_SOURCES = dprintf.c unctrl.c ffs.c
+LIB_SOURCES = dprintf.c unctrl.c ffs.c init.c
 
 libmisc_la_LDFLAGS = -Xcompiler -nostdlib
 
Index: src/newlib/libc/misc/init.c
diff -u /dev/null src/newlib/libc/misc/init.c:1.1
--- /dev/null	Thu May 12 14:25:29 2005
+++ src/newlib/libc/misc/init.c	Fri Jan  7 18:04:39 2005
@@ -0,0 +1,60 @@
+/*
+ * Copyright (C) 2004 CodeSourcery, LLC
+ *
+ * Permission to use, copy, modify, and distribute this file
+ * for any purpose is hereby granted without fee, provided that
+ * the above copyright notice and this notice appears in all
+ * copies.
+ *
+ * This file is distributed WITHOUT ANY WARRANTY; without even the implied
+ * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ */
+
+/* Handle ELF .{pre_init,init,fini}_array sections.  */
+#include <sys/types.h>
+
+#ifdef HAVE_INITFINI_ARRAY
+
+/* These magic symbols are provided by the linker.  */
+extern void (*__preinit_array_start []) (void) __attribute__((weak));
+extern void (*__preinit_array_end []) (void) __attribute__((weak));
+extern void (*__init_array_start []) (void) __attribute__((weak));
+extern void (*__init_array_end []) (void) __attribute__((weak));
+extern void (*__fini_array_start []) (void) __attribute__((weak));
+extern void (*__fini_array_end []) (void) __attribute__((weak));
+
+extern void _init (void);
+extern void _fini (void);
+
+/* Iterate over all the init routines.  */
+void
+__libc_init_array (void)
+{
+  size_t count;
+  size_t i;
+
+  count = __preinit_array_end - __preinit_array_start;
+  for (i = 0; i < count; i++)
+    __preinit_array_start[i] ();
+
+  _init ();
+
+  count = __init_array_end - __init_array_start;
+  for (i = 0; i < count; i++)
+    __init_array_start[i] ();
+}
+
+/* Run all the cleanup routines.  */
+void
+__libc_fini_array (void)
+{
+  size_t count;
+  size_t i;
+  
+  count = __fini_array_end - __fini_array_start;
+  for (i = 0; i < count; i++)
+    __fini_array_start[i] ();
+
+  _fini ();
+}
+#endif
Index: src/newlib/libc/stdio/clearerr.c
diff -u src/newlib/libc/stdio/clearerr.c:1.3 src/newlib/libc/stdio/clearerr.c:1.4
--- src/newlib/libc/stdio/clearerr.c:1.3	Fri Apr 23 20:01:54 2004
+++ src/newlib/libc/stdio/clearerr.c	Tue Feb  8 01:33:16 2005
@@ -54,12 +54,17 @@
 
 #include <_ansi.h>
 #include <stdio.h>
+#include "local.h"
+
+/* A subroutine version of the macro clearerr.  */
+
 #undef	clearerr
 
 _VOID
 _DEFUN(clearerr, (fp),
        FILE * fp)
 {
+  CHECK_INIT(_REENT);
   _flockfile (fp);
   __sclearerr (fp);
   _funlockfile (fp);
Index: src/newlib/libc/stdio/fclose.c
diff -u src/newlib/libc/stdio/fclose.c:1.9 src/newlib/libc/stdio/fclose.c:1.10
--- src/newlib/libc/stdio/fclose.c:1.9	Fri Jun 11 20:37:10 2004
+++ src/newlib/libc/stdio/fclose.c	Tue Feb  8 01:33:16 2005
@@ -76,10 +76,10 @@
 
   __sfp_lock_acquire ();
 
+  CHECK_INIT (rptr);
+
   _flockfile (fp);
   
-  CHECK_INIT (fp);
-
   if (fp->_flags == 0)		/* not open! */
     {
       _funlockfile (fp);
Index: src/newlib/libc/stdio/feof.c
diff -u src/newlib/libc/stdio/feof.c:1.3 src/newlib/libc/stdio/feof.c:1.4
--- src/newlib/libc/stdio/feof.c:1.3	Fri Apr 23 20:01:54 2004
+++ src/newlib/libc/stdio/feof.c	Tue Feb  8 01:33:16 2005
@@ -46,6 +46,9 @@
 */
 
 #include <stdio.h>
+#include "local.h"
+
+/* A subroutine version of the macro feof.  */
 
 #undef feof
 
@@ -54,6 +57,7 @@
        FILE * fp)
 {
   int result;
+  CHECK_INIT(_REENT);
   _flockfile (fp);
   result = __sfeof (fp);
   _funlockfile (fp);
Index: src/newlib/libc/stdio/ferror.c
diff -u src/newlib/libc/stdio/ferror.c:1.3 src/newlib/libc/stdio/ferror.c:1.4
--- src/newlib/libc/stdio/ferror.c:1.3	Fri Apr 23 20:01:54 2004
+++ src/newlib/libc/stdio/ferror.c	Tue Feb  8 01:33:16 2005
@@ -55,6 +55,7 @@
 
 #include <_ansi.h>
 #include <stdio.h>
+#include "local.h"
 
 /* A subroutine version of the macro ferror.  */
 
@@ -65,6 +66,7 @@
        FILE * fp)
 {
   int result;
+  CHECK_INIT(_REENT);
   _flockfile (fp);
   result = __sferror (fp);
   _funlockfile (fp);
Index: src/newlib/libc/stdio/fflush.c
diff -u src/newlib/libc/stdio/fflush.c:1.4 src/newlib/libc/stdio/fflush.c:1.5
--- src/newlib/libc/stdio/fflush.c:1.4	Fri Apr 23 20:01:54 2004
+++ src/newlib/libc/stdio/fflush.c	Tue Feb  8 01:33:16 2005
@@ -67,9 +67,9 @@
   if (fp == NULL)
     return _fwalk (_GLOBAL_REENT, fflush);
 
-  _flockfile (fp);
+  CHECK_INIT (_REENT);
 
-  CHECK_INIT (fp);
+  _flockfile (fp);
 
   t = fp->_flags;
   if ((t & __SWR) == 0 || (p = fp->_bf._base) == NULL)
Index: src/newlib/libc/stdio/fgetc.c
diff -u src/newlib/libc/stdio/fgetc.c:1.3 src/newlib/libc/stdio/fgetc.c:1.4
--- src/newlib/libc/stdio/fgetc.c:1.3	Fri Apr 23 20:01:54 2004
+++ src/newlib/libc/stdio/fgetc.c	Tue Feb  8 01:33:16 2005
@@ -55,12 +55,14 @@
 
 #include <_ansi.h>
 #include <stdio.h>
+#include "local.h"
 
 int
 _DEFUN(fgetc, (fp),
        FILE * fp)
 {
   int result;
+  CHECK_INIT(_REENT);
   _flockfile (fp);
   result = __sgetc (fp);
   _funlockfile (fp);
Index: src/newlib/libc/stdio/fgetpos.c
diff -u src/newlib/libc/stdio/fgetpos.c:1.5 src/newlib/libc/stdio/fgetpos.c:1.6
--- src/newlib/libc/stdio/fgetpos.c:1.5	Fri Apr 23 20:01:54 2004
+++ src/newlib/libc/stdio/fgetpos.c	Tue Feb  8 01:33:16 2005
@@ -81,15 +81,12 @@
        FILE * fp           _AND
        _fpos_t * pos)
 {
-  _flockfile (fp);
   *pos = _ftell_r (ptr, fp);
 
   if (*pos != -1)
     {
-      _funlockfile (fp);
       return 0;
     }
-  _funlockfile (fp);
   return 1;
 }
 
Index: src/newlib/libc/stdio/fgets.c
diff -u src/newlib/libc/stdio/fgets.c:1.4 src/newlib/libc/stdio/fgets.c:1.5
--- src/newlib/libc/stdio/fgets.c:1.4	Fri Apr 23 20:01:54 2004
+++ src/newlib/libc/stdio/fgets.c	Tue Feb  8 01:33:16 2005
@@ -80,6 +80,8 @@
 
   s = buf;
 
+  CHECK_INIT(_REENT);
+
   _flockfile (fp);
 #ifdef __SCLE
   if (fp->_flags & __SCLE)
Index: src/newlib/libc/stdio/fileno.c
diff -u src/newlib/libc/stdio/fileno.c:1.3 src/newlib/libc/stdio/fileno.c:1.4
--- src/newlib/libc/stdio/fileno.c:1.3	Fri Apr 23 20:01:54 2004
+++ src/newlib/libc/stdio/fileno.c	Tue Feb  8 01:33:16 2005
@@ -54,8 +54,8 @@
        FILE * f)
 {
   int result;
+  CHECK_INIT (_REENT);
   _flockfile (f);
-  CHECK_INIT (f);
   result = __sfileno (f);
   _funlockfile (f);
   return result;
Index: src/newlib/libc/stdio/findfp.c
diff -u src/newlib/libc/stdio/findfp.c:1.15 src/newlib/libc/stdio/findfp.c:1.16
--- src/newlib/libc/stdio/findfp.c:1.15	Fri Jun 11 20:37:10 2004
+++ src/newlib/libc/stdio/findfp.c	Tue Feb  8 01:05:50 2005
@@ -163,6 +163,14 @@
 _DEFUN(__sinit, (s),
        struct _reent *s)
 {
+  __sinit_lock_acquire ();
+
+  if (s->__sdidinit)
+    {
+      __sinit_lock_release ();
+      return;
+    }
+
   /* make sure we clean up on exit */
   s->__cleanup = _cleanup_r;	/* conservative */
   s->__sdidinit = 1;
@@ -192,11 +200,13 @@
 
   std (s->_stderr, __SWR | __SNBF, 2, s);
 
+  __sinit_lock_release ();
 }
 
 #ifndef __SINGLE_THREAD__
 
 __LOCK_INIT_RECURSIVE(static, __sfp_lock);
+__LOCK_INIT_RECURSIVE(static, __sinit_lock);
 
 _VOID
 _DEFUN_VOID(__sfp_lock_acquire)
@@ -210,6 +220,18 @@
   __lock_release_recursive (__sfp_lock); 
 }
 
+_VOID
+_DEFUN_VOID(__sinit_lock_acquire)
+{
+  __lock_acquire_recursive (__sinit_lock); 
+}
+
+_VOID
+_DEFUN_VOID(__sinit_lock_release)
+{
+  __lock_release_recursive (__sinit_lock); 
+}
+
 /* Walkable file locking routine.  */
 static int
 _DEFUN(__fp_lock, (ptr),
Index: src/newlib/libc/stdio/fputc.c
diff -u src/newlib/libc/stdio/fputc.c:1.3 src/newlib/libc/stdio/fputc.c:1.4
--- src/newlib/libc/stdio/fputc.c:1.3	Fri Apr 23 20:01:55 2004
+++ src/newlib/libc/stdio/fputc.c	Tue Feb  8 01:33:16 2005
@@ -59,6 +59,7 @@
 
 #include <_ansi.h>
 #include <stdio.h>
+#include "local.h"
 
 int
 _DEFUN(fputc, (ch, file),
@@ -66,6 +67,7 @@
        FILE * file)
 {
   int result;
+  CHECK_INIT(_REENT);
    _flockfile (file);
   result = putc (ch, file);
   _funlockfile (file);
Index: src/newlib/libc/stdio/fputs.c
diff -u src/newlib/libc/stdio/fputs.c:1.3 src/newlib/libc/stdio/fputs.c:1.4
--- src/newlib/libc/stdio/fputs.c:1.3	Fri Apr 23 20:01:55 2004
+++ src/newlib/libc/stdio/fputs.c	Tue Feb  8 01:33:16 2005
@@ -51,6 +51,7 @@
 #include <stdio.h>
 #include <string.h>
 #include "fvwrite.h"
+#include "local.h"
 
 /*
  * Write the given string to the given file.
@@ -69,6 +70,9 @@
   iov.iov_len = uio.uio_resid = strlen (s);
   uio.uio_iov = &iov;
   uio.uio_iovcnt = 1;
+
+  CHECK_INIT(_REENT);
+
   _flockfile (fp);
   result = __sfvwrite (fp, &uio);
   _funlockfile (fp);
Index: src/newlib/libc/stdio/fread.c
diff -u src/newlib/libc/stdio/fread.c:1.9 src/newlib/libc/stdio/fread.c:1.10
--- src/newlib/libc/stdio/fread.c:1.9	Mon Dec 13 19:42:16 2004
+++ src/newlib/libc/stdio/fread.c	Tue Feb  8 01:33:16 2005
@@ -125,6 +125,8 @@
   if ((resid = count * size) == 0)
     return 0;
 
+  CHECK_INIT(_REENT);
+
   _flockfile (fp);
   if (fp->_r < 0)
     fp->_r = 0;
Index: src/newlib/libc/stdio/freopen.c
diff -u src/newlib/libc/stdio/freopen.c:1.11 src/newlib/libc/stdio/freopen.c:1.12
--- src/newlib/libc/stdio/freopen.c:1.11	Fri Jun 11 20:37:10 2004
+++ src/newlib/libc/stdio/freopen.c	Tue Feb  8 01:33:16 2005
@@ -91,9 +91,9 @@
 
   __sfp_lock_acquire ();
 
-  _flockfile (fp);
+  CHECK_INIT (ptr);
 
-  CHECK_INIT (fp);
+  _flockfile (fp);
 
   if ((flags = __sflags (ptr, mode, &oflags)) == 0)
     {
Index: src/newlib/libc/stdio/fseek.c
diff -u src/newlib/libc/stdio/fseek.c:1.10 src/newlib/libc/stdio/fseek.c:1.11
--- src/newlib/libc/stdio/fseek.c:1.10	Fri Apr 23 20:01:55 2004
+++ src/newlib/libc/stdio/fseek.c	Tue Feb  8 01:33:16 2005
@@ -129,11 +129,11 @@
   struct stat st;
   int havepos;
 
-  _flockfile (fp);
-
   /* Make sure stdio is set up.  */
 
-  CHECK_INIT (fp);
+  CHECK_INIT (ptr);
+
+  _flockfile (fp);
 
   /* If we've been doing some writing, and we're in append mode
      then we don't really know where the filepos is.  */
Index: src/newlib/libc/stdio/ftell.c
diff -u src/newlib/libc/stdio/ftell.c:1.7 src/newlib/libc/stdio/ftell.c:1.9
--- src/newlib/libc/stdio/ftell.c:1.7	Fri Apr 23 20:01:55 2004
+++ src/newlib/libc/stdio/ftell.c	Tue Feb  8 01:33:16 2005
@@ -105,11 +105,11 @@
 {
   _fpos_t pos;
 
-  _flockfile (fp);
-
   /* Ensure stdio is set up.  */
 
-  CHECK_INIT (fp);
+  CHECK_INIT (ptr);
+
+  _flockfile (fp);
 
   if (fp->_seek == NULL)
     {
@@ -143,7 +143,7 @@
       if (HASUB (fp))
 	pos -= fp->_ur;
     }
-  else if (fp->_flags & __SWR && fp->_p != NULL)
+  else if ((fp->_flags & __SWR) && fp->_p != NULL)
     {
       /*
        * Writing.  Any buffered characters cause the
Index: src/newlib/libc/stdio/fwrite.c
diff -u src/newlib/libc/stdio/fwrite.c:1.3 src/newlib/libc/stdio/fwrite.c:1.4
--- src/newlib/libc/stdio/fwrite.c:1.3	Fri Apr 23 20:01:55 2004
+++ src/newlib/libc/stdio/fwrite.c	Tue Feb  8 01:33:16 2005
@@ -99,6 +99,8 @@
    * generally slow and since this occurs whenever size==0.
    */
 
+  CHECK_INIT(_REENT);
+
   _flockfile (fp);
   if (__sfvwrite (fp, &uio) == 0)
     {
Index: src/newlib/libc/stdio/getc.c
diff -u src/newlib/libc/stdio/getc.c:1.3 src/newlib/libc/stdio/getc.c:1.4
--- src/newlib/libc/stdio/getc.c:1.3	Fri Apr 23 20:01:55 2004
+++ src/newlib/libc/stdio/getc.c	Tue Feb  8 01:33:16 2005
@@ -64,6 +64,7 @@
 
 #include <_ansi.h>
 #include <stdio.h>
+#include "local.h"
 
 /*
  * A subroutine version of the macro getc.
@@ -76,8 +77,8 @@
        register FILE *fp)
 {
   int result;
+  CHECK_INIT (_REENT);
   _flockfile (fp);
-  /* CHECK_INIT is called (eventually) by __srefill.  */
   result = __sgetc (fp);
   _funlockfile (fp);
   return result;
Index: src/newlib/libc/stdio/getchar.c
diff -u src/newlib/libc/stdio/getchar.c:1.3 src/newlib/libc/stdio/getchar.c:1.4
--- src/newlib/libc/stdio/getchar.c:1.3	Fri Apr 23 20:01:55 2004
+++ src/newlib/libc/stdio/getchar.c	Tue Feb  8 01:33:16 2005
@@ -82,7 +82,7 @@
 _DEFUN(_getchar_r, (f),
        struct _reent *f)
 {
-  _REENT_SMALL_CHECK_INIT (_stdin_r (f));
+  _REENT_SMALL_CHECK_INIT (f);
   return getc (_stdin_r (f));
 }
 
Index: src/newlib/libc/stdio/getdelim.c
diff -u src/newlib/libc/stdio/getdelim.c:1.3 src/newlib/libc/stdio/getdelim.c:1.4
--- src/newlib/libc/stdio/getdelim.c:1.3	Fri Apr 23 20:01:55 2004
+++ src/newlib/libc/stdio/getdelim.c	Tue Feb  8 01:33:17 2005
@@ -79,9 +79,9 @@
       *n = DEFAULT_LINE_SIZE;
     }
 
-  _flockfile (fp);
+  CHECK_INIT (_REENT);
 
-  CHECK_INIT (fp);
+  _flockfile (fp);
 
   numbytes = *n;
   ptr = buf;
Index: src/newlib/libc/stdio/iprintf.c
diff -u src/newlib/libc/stdio/iprintf.c:1.6 src/newlib/libc/stdio/iprintf.c:1.7
--- src/newlib/libc/stdio/iprintf.c:1.6	Wed Nov 24 00:45:41 2004
+++ src/newlib/libc/stdio/iprintf.c	Tue Feb  8 01:33:17 2005
@@ -40,7 +40,7 @@
   int ret;
   va_list ap;
 
-  _REENT_SMALL_CHECK_INIT (_stdout_r (_REENT));
+  _REENT_SMALL_CHECK_INIT (_REENT);
 #ifdef _HAVE_STDC
   va_start (ap, fmt);
 #else
@@ -67,7 +67,7 @@
   int ret;
   va_list ap;
 
-  _REENT_SMALL_CHECK_INIT (_stdout_r (ptr));
+  _REENT_SMALL_CHECK_INIT (ptr);
 #ifdef _HAVE_STDC
   va_start (ap, fmt);
 #else
Index: src/newlib/libc/stdio/iscanf.c
diff -u src/newlib/libc/stdio/iscanf.c:1.1 src/newlib/libc/stdio/iscanf.c:1.2
--- src/newlib/libc/stdio/iscanf.c:1.1	Wed Nov 24 00:45:41 2004
+++ src/newlib/libc/stdio/iscanf.c	Tue Feb  8 01:33:17 2005
@@ -39,7 +39,7 @@
   int ret;
   va_list ap;
 
-  _REENT_SMALL_CHECK_INIT (_stdin_r (_REENT));
+  _REENT_SMALL_CHECK_INIT (_REENT);
 #ifdef _HAVE_STDC
   va_start (ap, fmt);
 #else
@@ -65,7 +65,7 @@
   int ret;
   va_list ap;
 
-  _REENT_SMALL_CHECK_INIT (_stdin_r (ptr));
+  _REENT_SMALL_CHECK_INIT (ptr);
 #ifdef _HAVE_STDC
   va_start (ap, fmt);
 #else
Index: src/newlib/libc/stdio/local.h
diff -u src/newlib/libc/stdio/local.h:1.14 src/newlib/libc/stdio/local.h:1.16
--- src/newlib/libc/stdio/local.h:1.14	Wed Nov 24 00:45:41 2004
+++ src/newlib/libc/stdio/local.h	Tue Feb  8 01:33:17 2005
@@ -49,11 +49,11 @@
 
 /* Called by the main entry point fns to ensure stdio has been initialized.  */
 
-#define CHECK_INIT(fp) \
+#define CHECK_INIT(ptr) \
   do						\
     {						\
-      if (_REENT && !_REENT->__sdidinit)	\
-	__sinit (_REENT);			\
+      if ((ptr) && !(ptr)->__sdidinit)		\
+	__sinit (ptr);				\
     }						\
   while (0)
 
@@ -95,7 +95,11 @@
 #ifdef __SINGLE_THREAD__
 #define __sfp_lock_acquire()
 #define __sfp_lock_release()
+#define __sinit_lock_acquire()
+#define __sinit_lock_release()
 #else
 _VOID _EXFUN(__sfp_lock_acquire,(_VOID));
 _VOID _EXFUN(__sfp_lock_release,(_VOID));
+_VOID _EXFUN(__sinit_lock_acquire,(_VOID));
+_VOID _EXFUN(__sinit_lock_release,(_VOID));
 #endif
Index: src/newlib/libc/stdio/perror.c
diff -u src/newlib/libc/stdio/perror.c:1.3 src/newlib/libc/stdio/perror.c:1.4
--- src/newlib/libc/stdio/perror.c:1.3	Fri Apr 23 20:01:55 2004
+++ src/newlib/libc/stdio/perror.c	Tue Feb  8 01:33:17 2005
@@ -74,7 +74,7 @@
 {
   char *error;
 
-  _REENT_SMALL_CHECK_INIT (_stderr_r (ptr));
+  _REENT_SMALL_CHECK_INIT (ptr);
   if (s != NULL && *s != '\0')
     {
       fputs (s, _stderr_r (ptr));
Index: src/newlib/libc/stdio/printf.c
diff -u src/newlib/libc/stdio/printf.c:1.4 src/newlib/libc/stdio/printf.c:1.5
--- src/newlib/libc/stdio/printf.c:1.4	Fri Apr 23 20:01:55 2004
+++ src/newlib/libc/stdio/printf.c	Tue Feb  8 01:33:17 2005
@@ -39,7 +39,7 @@
   int ret;
   va_list ap;
 
-  _REENT_SMALL_CHECK_INIT (_stdout_r (ptr));
+  _REENT_SMALL_CHECK_INIT (ptr);
 #ifdef _HAVE_STDC
   va_start (ap, fmt);
 #else
@@ -65,7 +65,7 @@
   int ret;
   va_list ap;
 
-  _REENT_SMALL_CHECK_INIT (_stdout_r (_REENT));
+  _REENT_SMALL_CHECK_INIT (_REENT);
 #ifdef _HAVE_STDC
   va_start (ap, fmt);
 #else
Index: src/newlib/libc/stdio/putc.c
diff -u src/newlib/libc/stdio/putc.c:1.3 src/newlib/libc/stdio/putc.c:1.4
--- src/newlib/libc/stdio/putc.c:1.3	Fri Apr 23 20:01:55 2004
+++ src/newlib/libc/stdio/putc.c	Tue Feb  8 01:33:17 2005
@@ -67,6 +67,7 @@
 
 #include <_ansi.h>
 #include <stdio.h>
+#include "local.h"
 
 /*
  * A subroutine version of the macro putc.
@@ -80,8 +81,8 @@
        register FILE *fp)
 {
   int result;
+  CHECK_INIT (_REENT);
   _flockfile (fp);
-  /* CHECK_INIT is (eventually) called by __swbuf.  */
   result = __sputc (c, fp);
   _funlockfile (fp);
   return result;
Index: src/newlib/libc/stdio/putchar.c
diff -u src/newlib/libc/stdio/putchar.c:1.5 src/newlib/libc/stdio/putchar.c:1.6
--- src/newlib/libc/stdio/putchar.c:1.5	Fri Apr 23 20:01:55 2004
+++ src/newlib/libc/stdio/putchar.c	Tue Feb  8 01:33:17 2005
@@ -80,7 +80,7 @@
        struct _reent *ptr _AND
        int c)
 {
-  _REENT_SMALL_CHECK_INIT (_stdout_r (ptr));
+  _REENT_SMALL_CHECK_INIT (ptr);
   return putc (c, _stdout_r (ptr));
 }
 
Index: src/newlib/libc/stdio/puts.c
diff -u src/newlib/libc/stdio/puts.c:1.3 src/newlib/libc/stdio/puts.c:1.4
--- src/newlib/libc/stdio/puts.c:1.3	Fri Apr 23 20:01:55 2004
+++ src/newlib/libc/stdio/puts.c	Tue Feb  8 01:33:17 2005
@@ -90,7 +90,7 @@
   uio.uio_iov = &iov[0];
   uio.uio_iovcnt = 2;
 
-  _REENT_SMALL_CHECK_INIT (_stdout_r (ptr));
+  _REENT_SMALL_CHECK_INIT (ptr);
   return (__sfvwrite (_stdout_r (ptr), &uio) ? EOF : '\n');
 }
 
Index: src/newlib/libc/stdio/refill.c
diff -u src/newlib/libc/stdio/refill.c:1.5 src/newlib/libc/stdio/refill.c:1.6
--- src/newlib/libc/stdio/refill.c:1.5	Wed Nov 17 17:02:10 2004
+++ src/newlib/libc/stdio/refill.c	Tue Feb  8 01:33:17 2005
@@ -41,7 +41,7 @@
 {
   /* make sure stdio is set up */
 
-  CHECK_INIT (fp);
+  CHECK_INIT (_REENT);
 
   fp->_r = 0;			/* largely a convenience for callers */
 
Index: src/newlib/libc/stdio/scanf.c
diff -u src/newlib/libc/stdio/scanf.c:1.5 src/newlib/libc/stdio/scanf.c:1.6
--- src/newlib/libc/stdio/scanf.c:1.5	Fri Apr 23 20:01:55 2004
+++ src/newlib/libc/stdio/scanf.c	Tue Feb  8 01:33:17 2005
@@ -39,7 +39,7 @@
   int ret;
   va_list ap;
 
-  _REENT_SMALL_CHECK_INIT (_stdin_r (_REENT));
+  _REENT_SMALL_CHECK_INIT (_REENT);
 #ifdef _HAVE_STDC
   va_start (ap, fmt);
 #else
@@ -65,7 +65,7 @@
   int ret;
   va_list ap;
 
-  _REENT_SMALL_CHECK_INIT (_stdin_r (ptr));
+  _REENT_SMALL_CHECK_INIT (ptr);
 #ifdef _HAVE_STDC
   va_start (ap, fmt);
 #else
Index: src/newlib/libc/stdio/setvbuf.c
diff -u src/newlib/libc/stdio/setvbuf.c:1.4 src/newlib/libc/stdio/setvbuf.c:1.5
--- src/newlib/libc/stdio/setvbuf.c:1.4	Fri Apr 23 20:01:55 2004
+++ src/newlib/libc/stdio/setvbuf.c	Tue Feb  8 01:33:17 2005
@@ -104,9 +104,9 @@
 {
   int ret = 0;
 
-  _flockfile (fp);
+  CHECK_INIT (_REENT);
 
-  CHECK_INIT (fp);
+  _flockfile (fp);
 
   /*
    * Verify arguments.  The `int' limit on `size' is due to this
Index: src/newlib/libc/stdio/ungetc.c
diff -u src/newlib/libc/stdio/ungetc.c:1.5 src/newlib/libc/stdio/ungetc.c:1.6
--- src/newlib/libc/stdio/ungetc.c:1.5	Mon May  3 17:27:56 2004
+++ src/newlib/libc/stdio/ungetc.c	Tue Feb  8 01:33:17 2005
@@ -77,14 +77,14 @@
   if (c == EOF)
     return (EOF);
 
-  _flockfile (fp);
-  
   /* Ensure stdio has been initialized.
      ??? Might be able to remove this as some other stdio routine should
      have already been called to get the char we are un-getting.  */
 
-  CHECK_INIT (fp);
+  CHECK_INIT (rptr);
 
+  _flockfile (fp);
+  
   /* After ungetc, we won't be at eof anymore */
   fp->_flags &= ~__SEOF;
 
Index: src/newlib/libc/stdio/vfprintf.c
diff -u src/newlib/libc/stdio/vfprintf.c:1.37 src/newlib/libc/stdio/vfprintf.c:1.39
--- src/newlib/libc/stdio/vfprintf.c:1.37	Fri Jun 11 20:37:10 2004
+++ src/newlib/libc/stdio/vfprintf.c	Mon Mar 21 22:34:35 2005
@@ -157,6 +157,7 @@
  *
  * This code is large and complicated...
  */
+#include <newlib.h>
 
 #ifdef INTEGER_ONLY
 #define VFPRINTF vfiprintf
@@ -176,8 +177,6 @@
 
 #include <_ansi.h>
 #include <reent.h>
-#include <newlib.h>
-#include <reent.h>
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
@@ -533,8 +532,8 @@
 	    (u_long)GET_ARG (N, ap, u_int))
 #endif
 
+	CHECK_INIT (data);
 	_flockfile (fp);
-	CHECK_INIT (fp);
 
 	/* sorry, fprintf(read_only_file, "") returns EOF, not 0 */
 	if (cantwrite (fp)) {
Index: src/newlib/libc/stdio/vfscanf.c
diff -u src/newlib/libc/stdio/vfscanf.c:1.26 src/newlib/libc/stdio/vfscanf.c:1.30
--- src/newlib/libc/stdio/vfscanf.c:1.26	Wed Nov 24 00:45:41 2004
+++ src/newlib/libc/stdio/vfscanf.c	Thu Apr 28 18:26:08 2005
@@ -135,6 +135,7 @@
 #endif
 
 #ifdef FLOATING_POINT
+#include <math.h>
 #include <float.h>
 
 /* Currently a test is made to see if long double processing is warranted.
@@ -230,7 +231,7 @@
        _CONST char *fmt _AND 
        va_list ap)
 {
-  CHECK_INIT(fp);
+  CHECK_INIT(_REENT);
   return __SVFSCANF_R (_REENT, fp, fmt, ap);
 }
 
@@ -252,6 +253,7 @@
        _CONST char *fmt    _AND 
        va_list ap)
 {
+  CHECK_INIT(data);
   return __SVFSCANF_R (data, fp, fmt, ap);
 }
 
@@ -985,6 +987,7 @@
 	  long zeroes, exp_adjust;
 	  char *exp_start = NULL;
 	  unsigned width_left = 0;
+	  int nancount = 0;
 #ifdef hardway
 	  if (width == 0 || width > sizeof (buf) - 1)
 #else
@@ -1007,7 +1010,6 @@
 	       */
 	      switch (c)
 		{
-
 		case '0':
 		  if (flags & NDIGITS)
 		    {
@@ -1030,8 +1032,12 @@
 		case '7':
 		case '8':
 		case '9':
-		  flags &= ~(SIGNOK | NDIGITS);
-		  goto fok;
+		  if (nancount == 0)
+		    {
+		      flags &= ~(SIGNOK | NDIGITS);
+		      goto fok;
+		    }
+		  break;
 
 		case '+':
 		case '-':
@@ -1041,6 +1047,30 @@
 		      goto fok;
 		    }
 		  break;
+		case 'n':
+		case 'N':
+	          if (nancount == 0
+		      && (flags & (SIGNOK | NDIGITS | DPTOK | EXPOK)) ==
+		      	          (SIGNOK | NDIGITS | DPTOK | EXPOK))
+		    {
+		      flags &= ~(SIGNOK | DPTOK | EXPOK | NDIGITS);
+		      nancount = 1;
+		      goto fok;
+		    }
+		  else if (nancount == 2)
+		    {
+		      nancount = 3;
+		      goto fok;
+		    }
+		  break;
+		case 'a':
+		case 'A':
+		  if (nancount == 1)
+		    {
+		      nancount = 2;
+		      goto fok;
+		    }
+		  break;
 		case '.':
 		  if (flags & DPTOK)
 		    {
@@ -1082,7 +1112,24 @@
 	    }
 	  if (zeroes)
 	    flags &= ~NDIGITS;
-	  /*
+          /* We may have a 'N' or possibly even a 'Na' as the start of 'NaN', 
+	     only to run out of chars before it was complete (or having 
+	     encountered a non- matching char).  So check here if we have an 
+	     outstanding nancount, and if so put back the chars we did 
+	     swallow and treat as a failed match. */
+          if (nancount && nancount != 3)
+            {
+              /* Ok... what are we supposed to do in the event that the
+              __srefill call above was triggered in the middle of the partial
+              'NaN' and so we can't put it all back? */
+              while (nancount-- && (p > buf))
+                {
+                  ungetc (*(u_char *)--p, fp);
+                  --nread;
+                }
+              goto match_failure;
+            }
+          /*
 	   * If no digits, might be missing exponent digits
 	   * (just give back the exponent) or might be missing
 	   * regular digits, but had sign and/or decimal point.
@@ -1094,7 +1141,7 @@
 		  /* no digits at all */
 		  while (p > buf)
                     {
-		      ungetc (*(u_char *)-- p, fp);
+		      ungetc (*(u_char *)--p, fp);
                       --nread;
                     }
 		  goto match_failure;
@@ -1163,7 +1210,10 @@
 	      else
 		{
 		  flp = va_arg (ap, float *);
-		  *flp = res;
+		  if (isnan (res))
+		    *flp = nanf (NULL);
+		  else
+		    *flp = res;
 		}
 	      nassigned++;
 	    }
Index: src/newlib/libc/stdio/viprintf.c
diff -u src/newlib/libc/stdio/viprintf.c:1.1 src/newlib/libc/stdio/viprintf.c:1.2
--- src/newlib/libc/stdio/viprintf.c:1.1	Wed Nov 24 00:45:41 2004
+++ src/newlib/libc/stdio/viprintf.c	Tue Feb  8 01:33:17 2005
@@ -145,7 +145,7 @@
        _CONST char *fmt _AND
        va_list ap)
 {
-  _REENT_SMALL_CHECK_INIT (_stdout_r (_REENT));
+  _REENT_SMALL_CHECK_INIT (_REENT);
   return _vfiprintf_r (_REENT, _stdout_r (_REENT), fmt, ap);
 }
 
@@ -157,6 +157,6 @@
        _CONST char *fmt   _AND
        va_list ap)
 {
-  _REENT_SMALL_CHECK_INIT (_stdout_r (ptr));
+  _REENT_SMALL_CHECK_INIT (ptr);
   return _vfiprintf_r (ptr, _stdout_r (ptr), fmt, ap);
 }
Index: src/newlib/libc/stdio/viscanf.c
diff -u src/newlib/libc/stdio/viscanf.c:1.1 src/newlib/libc/stdio/viscanf.c:1.2
--- src/newlib/libc/stdio/viscanf.c:1.1	Wed Nov 24 00:45:41 2004
+++ src/newlib/libc/stdio/viscanf.c	Tue Feb  8 01:33:17 2005
@@ -121,7 +121,7 @@
        _CONST char *fmt _AND 
        va_list ap)
 {
-  _REENT_SMALL_CHECK_INIT (_stdin_r (_REENT));
+  _REENT_SMALL_CHECK_INIT (_REENT);
   return __svfiscanf_r (_REENT, _stdin_r (_REENT), fmt, ap);
 }
 
@@ -133,7 +133,7 @@
        _CONST char *fmt   _AND 
        va_list ap)
 {
-  _REENT_SMALL_CHECK_INIT (_stdin_r (ptr));
+  _REENT_SMALL_CHECK_INIT (ptr);
   return __svfiscanf_r (ptr, _stdin_r (ptr), fmt, ap);
 }
 
Index: src/newlib/libc/stdio/vprintf.c
diff -u src/newlib/libc/stdio/vprintf.c:1.5 src/newlib/libc/stdio/vprintf.c:1.6
--- src/newlib/libc/stdio/vprintf.c:1.5	Fri Apr 23 20:01:55 2004
+++ src/newlib/libc/stdio/vprintf.c	Tue Feb  8 01:33:17 2005
@@ -33,7 +33,7 @@
        _CONST char *fmt _AND
        va_list ap)
 {
-  _REENT_SMALL_CHECK_INIT (_stdout_r (_REENT));
+  _REENT_SMALL_CHECK_INIT (_REENT);
   return _vfprintf_r (_REENT, _stdout_r (_REENT), fmt, ap);
 }
 
@@ -45,6 +45,6 @@
        _CONST char *fmt   _AND
        va_list ap)
 {
-  _REENT_SMALL_CHECK_INIT (_stdout_r (ptr));
+  _REENT_SMALL_CHECK_INIT (ptr);
   return _vfprintf_r (ptr, _stdout_r (ptr), fmt, ap);
 }
Index: src/newlib/libc/stdio/vscanf.c
diff -u src/newlib/libc/stdio/vscanf.c:1.3 src/newlib/libc/stdio/vscanf.c:1.4
--- src/newlib/libc/stdio/vscanf.c:1.3	Fri Apr 23 20:01:55 2004
+++ src/newlib/libc/stdio/vscanf.c	Tue Feb  8 01:33:17 2005
@@ -34,7 +34,7 @@
        _CONST char *fmt _AND 
        va_list ap)
 {
-  _REENT_SMALL_CHECK_INIT (_stdin_r (_REENT));
+  _REENT_SMALL_CHECK_INIT (_REENT);
   return __svfscanf_r (_REENT, _stdin_r (_REENT), fmt, ap);
 }
 
@@ -46,7 +46,7 @@
        _CONST char *fmt   _AND 
        va_list ap)
 {
-  _REENT_SMALL_CHECK_INIT (_stdin_r (ptr));
+  _REENT_SMALL_CHECK_INIT (ptr);
   return __svfscanf_r (ptr, _stdin_r (ptr), fmt, ap);
 }
 
Index: src/newlib/libc/stdio/wbuf.c
diff -u src/newlib/libc/stdio/wbuf.c:1.2 src/newlib/libc/stdio/wbuf.c:1.3
--- src/newlib/libc/stdio/wbuf.c:1.2	Fri Apr 23 20:01:55 2004
+++ src/newlib/libc/stdio/wbuf.c	Tue Feb  8 01:33:17 2005
@@ -40,7 +40,7 @@
 
   /* Ensure stdio has been initialized.  */
 
-  CHECK_INIT (fp);
+  CHECK_INIT (_REENT);
 
   /*
    * In case we cannot write, or longjmp takes us out early,
Index: src/newlib/libc/stdio/wsetup.c
diff -u src/newlib/libc/stdio/wsetup.c:1.2 src/newlib/libc/stdio/wsetup.c:1.3
--- src/newlib/libc/stdio/wsetup.c:1.2	Fri Apr 23 20:01:55 2004
+++ src/newlib/libc/stdio/wsetup.c	Tue Feb  8 01:33:17 2005
@@ -34,7 +34,7 @@
 {
   /* Make sure stdio is set up.  */
 
-  CHECK_INIT (fp);
+  CHECK_INIT (_REENT);
 
   /*
    * If we are not writing, we had better be reading and writing.
Index: src/newlib/libc/stdio64/fgetpos64.c
diff -u src/newlib/libc/stdio64/fgetpos64.c:1.3 src/newlib/libc/stdio64/fgetpos64.c:1.4
--- src/newlib/libc/stdio64/fgetpos64.c:1.3	Fri Aug 22 18:52:25 2003
+++ src/newlib/libc/stdio64/fgetpos64.c	Tue Feb  8 01:33:17 2005
@@ -60,15 +60,12 @@
 	FILE * fp _AND
 	_fpos64_t * pos)
 {
-  _flockfile(fp);
   *pos = (_fpos64_t)_ftello64_r (ptr, fp);
 
   if (*pos != -1)
     {
-      _funlockfile(fp);
       return 0;
     }
-  _funlockfile(fp);
   return 1;
 }
 
